> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List Memberships

> Lists all memberships of a group.

`Unary` · [`Groups`](/docs/api-reference/generated/group/overview)

Lists all memberships of a group.

Use this method to:

* View all members of a group
* Audit group membership

### Examples

* List group members:

  Shows all members of a specific group.

  ```yaml theme={null}
  groupId: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  pagination:
    pageSize: 20
  ```

### Authorization

All organization members can view group membership (transparency model).

## Endpoint

```text theme={null}
POST /api/gitpod.v1.GroupService/ListMemberships
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.GroupService/ListMemberships" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "pagination": {
      "pageSize": 1
    }
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.group_pb2 as group_pb2
  import gitpod.v1.pagination_pb2 as pagination_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = group_pb2.ListMembershipsRequest(
      pagination=pagination_pb2.PaginationRequest(
          page_size=1,
      ),
  )
  response = ona.services.group.list_memberships(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { ListMembershipsRequestSchema } from "@gitpod/sdk/gitpod/v1/group_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(ListMembershipsRequestSchema, {
      pagination: {
        pageSize: 1,
      },
    });
    const response = await ona.services.group.listMemberships(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.ListMembershipsRequest{
  		Pagination: &gitpodpb.PaginationRequest{
  			PageSize: 1,
  		},
  	})
  	response, err := ona.Services.Group.ListMemberships(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "pagination": {
      "pageSize": 1
    }
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.ListMembershipsRequest`

ListMemberships messages

| Field        | Type                                                      | Required | Description                                                        |
| ------------ | --------------------------------------------------------- | -------- | ------------------------------------------------------------------ |
| `pagination` | [PaginationRequest](#type-gitpod-v1-pagination-request)   | No       | pagination contains the pagination options for listing memberships |
| `groupId`    | string                                                    | No       | Constraints: `string.uuid=true`.                                   |
| `filter`     | [Filter](#type-gitpod-v1-list-memberships-request-filter) | No       | filter contains options for filtering the list of memberships.     |

## Response

`gitpod.v1.ListMembershipsResponse`

| Field        | Type                                                         | Required | Description |
| ------------ | ------------------------------------------------------------ | -------- | ----------- |
| `pagination` | [PaginationResponse](#type-gitpod-v1-pagination-response)    | No       |             |
| `members`    | array of [GroupMembership](#type-gitpod-v1-group-membership) | No       |             |

## Related types

<a id="type-gitpod-v1-group-membership" />

<Accordion title="GroupMembership">
  GroupMembership represents a subject's membership in a group

  `gitpod.v1.GroupMembership`

  | Field       | Type                               | Required | Description                                                                 |
  | ----------- | ---------------------------------- | -------- | --------------------------------------------------------------------------- |
  | `id`        | string                             | No       | Unique identifier for the group membership Constraints: `string.uuid=true`. |
  | `subject`   | [Subject](#type-gitpod-v1-subject) | No       | Subject (user, runner, environment, service account, etc.)                  |
  | `groupId`   | string                             | No       | Group identifier Constraints: `string.uuid=true`.                           |
  | `name`      | string                             | No       | Subject's display name                                                      |
  | `avatarUrl` | string                             | No       | Subject's avatar URL                                                        |
</Accordion>

<a id="type-gitpod-v1-list-memberships-request-filter" />

<Accordion title="Filter">
  `gitpod.v1.ListMembershipsRequest.Filter`

  | Field    | Type   | Required | Description                                                                                                                                        |
  | -------- | ------ | -------- | -------------------------------------------------------------------------------------------------------------------------------------------------- |
  | `search` | string | No       | search performs case-insensitive search across member name, email, ID, and service account name and description Constraints: `string.max_len=256`. |
</Accordion>

<a id="type-gitpod-v1-pagination-request" />

<Accordion title="PaginationRequest">
  `gitpod.v1.PaginationRequest`

  | Field      | Type    | Required | Description                                                                                                                              |
  | ---------- | ------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------- |
  | `pageSize` | integer | No       | Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. Constraints: `int32.gte=0, int32.lte=100`. |
  | `token`    | string  | No       | Token for the next set of results that was returned as next\_token of a PaginationResponse                                               |
</Accordion>

<a id="type-gitpod-v1-pagination-response" />

<Accordion title="PaginationResponse">
  `gitpod.v1.PaginationResponse`

  | Field       | Type   | Required | Description                                                                             |
  | ----------- | ------ | -------- | --------------------------------------------------------------------------------------- |
  | `nextToken` | string | No       | Token passed for retrieving the next set of results. Empty if there are no more results |
</Accordion>

<a id="type-gitpod-v1-subject" />

<Accordion title="Subject">
  `gitpod.v1.Subject`

  | Field       | Type                                   | Required | Description                                                                      |
  | ----------- | -------------------------------------- | -------- | -------------------------------------------------------------------------------- |
  | `id`        | string                                 | No       | id is the UUID of the subject Constraints: `ignore=1, string.uuid=true`.         |
  | `principal` | [Principal](#enum-gitpod-v1-principal) | No       | Principal is the principal of the subject Constraints: `enum.defined_only=true`. |
</Accordion>

<a id="enum-gitpod-v1-principal" />

<Accordion title="Principal">
  | Value                       | Number | Description |
  | --------------------------- | -----: | ----------- |
  | `PRINCIPAL_UNSPECIFIED`     |      0 |             |
  | `PRINCIPAL_ACCOUNT`         |      1 |             |
  | `PRINCIPAL_USER`            |      2 |             |
  | `PRINCIPAL_RUNNER`          |      3 |             |
  | `PRINCIPAL_ENVIRONMENT`     |      4 |             |
  | `PRINCIPAL_SERVICE_ACCOUNT` |      5 |             |
  | `PRINCIPAL_RUNNER_MANAGER`  |      6 |             |
</Accordion>
